#include <bits/stdc++.h>
int main(){
    int s[]={0,51,14,33,2,49,16,35,13,32,1,50,15,34,3,48,52,63,30,23,28,25,36,17,31,12,61,26,59,22,47,4,62,53,10,29,24,27,18,37,11,42,55,60,21,58,5,46,54,9,40,57,44,7,38,19,41,56,43,8,39,20,45,6};
    int x[64],y[64],i,j; std::cin>>j>>i;
    j=s[(i-1)*8+j-1];
    for(i=0;i<64;i++)std::cout<<(s[i]-j+64)%64+1<<' ';
}
 